#!/usr/bin/env ruby

# äƤ뤳ȡ
# ʤĤߤѤ sites.lirs ɤǡ
# fork ơ
# wget ơ
# w3m ǥ󥰤ơ
#  diff ơ
# diff ̤ >  <  grep ơ
# ѤäƤ OK

require 'uri'

require 'mycsv'

class Site
  attr_reader :name, :url, :mod
  def initialize(n, u, m)
	@name = n
	@url = u
	@mod = m
  end
end

lirs = 'sites.lirs'
if (ARGV[0]) then
  lirs = ARGV[0]
end

csv = CSVParser.new(lirs)

system("rm -rf olddowns")
system("mv downs olddowns")
system("mkdir downs")

now = Time.now

dat = Hash.new
datOld = Hash.new
if (File.exists?('wda.dat')) then
  File.open('wda.dat') do |datFile|
	datOld = Marshal.load(datFile)
  end
end

processes = Array.new

csv.each do |a|
  pid = fork do
	if (a[0] != 'LIRS') then
	  print "LIRS ʳϤ褯狼ޤ\n"
	  next
	end
	system("mkdir 'downs/#{a[6]}'")
	Dir.chdir("downs/#{a[6]}")
	system("wget -U WWDGWA/0.0.1 '#{a[5]}' >& /dev/null")
	system("mv * down.html")
	if (a[1] != '0') then
	  system("perl -i -p -e 'if (-1 != index $_, \"#{a[1]}\") { $on = 1; } if (!$on) { $_ = \"\" } ' down.html")
	end
	if (a[2] != '0') then
	  system("perl -i -p -e 'if ($off) { $_ = \"\" } if (-1 != index $_, \"#{a[2]}\") { $off = 1; } ' down.html")
	end
	system('w3m -dump down.html > down')

	updated = false
	if (File.exists?("../../olddowns/#{a[6]}/down")) then
	  system("diff '../../olddowns/#{a[6]}/down' down > diff")
	  incs = `grep '>' diff | wc -l | cut -d 'd' -f 1`.to_i
	  decs = `grep '<' diff | wc -l | cut -d 'd' -f 1`.to_i
	  if (incs > 1 || (incs == 1 && decs == 0)) then
		updated = true
	  else
		system("cp '../../olddowns/#{a[6]}/down' down")
	  end
	else
	  updated = true
	end

	if (updated) then
	  system("touch updated")
	end
  end

  processes.push(pid)
end

num = 0
all = processes.size
prev = 0
print "|          |\b\b\b\b\b\b\b\b\b\b\b"
$stdout.flush()
processes.each do |pid|
  Process.waitpid(pid)
  num += 1
  per = (num * 10.0 / all).to_i
  while (prev < per)
	prev += 1
	print "#"
	$stdout.flush()
  end
end
print "\n"

csv.each do |a|
  if (File.exists?("downs/#{a[6]}/updated")) then
	s = Site.new(a[6], a[5], now)
	dat[a[5]] = s
  else
	if (datOld[a[5]] != nil) then
	  dat[a[5]] = datOld[a[5]]
	end
  end
end

File.open('wda.dat', 'w') do |datFile|
  Marshal.dump(dat, datFile)
end

File.open('a.html', 'w') do |ofile|
  ofile.print("<p>ƥʤǤ</p>\n<ul>\n")
  dat.values.sort { |x,y| y.mod <=> x.mod }.each do |d|
	ofile.print "<li><a href=\"#{d.url}\">#{d.name}</a> "
	if (d.mod == now) then
	  ofile.print "(new) "
	end
	ofile.print "#{d.mod.strftime('%y/%m/%d/%H/%M/%S')} "
	encodedDown = URI.encode("downs/#{d.name}/down.html")
	encodedDiff = URI.encode("downs/#{d.name}/diff")
	ofile.print "(<a href=#{encodedDown}>down</a>) "
	ofile.print "(<a href=#{encodedDiff}>diff</a>)\n"
  end
  ofile.print("</ul>\n")
end

